#ifndef DRAWWIDGET_H
#define DRAWWIDGET_H

#include <sparrowrenderer.h>
#include <QOpenGLWidget>
#include <QTimer>

class PixelPipeline;
class Map;
class FrameBuffer;

class DrawWidget : public QOpenGLWidget
{
    private:
        Q_OBJECT

        SparrowRenderer renderer;
        QTimer openglRefreshTimer;
        
        // camera handling variables
        QPoint lastMousePos;
        bool grabbedMouse;
        Map *m_map;
        FrameBuffer *m_Qt_fbo;
        PixelPipeline *m_pipeline;
        
    protected:
        // Output
        virtual void initializeGL();
        virtual void paintGL();
        virtual void resizeGL(int w, int h);

        // Input
        void mouseMoveEvent(QMouseEvent *event);
        void mousePressEvent(QMouseEvent *event);
        void mouseDoubleClickEvent(QMouseEvent * event);
        void mouseReleaseEvent(QMouseEvent *event);
        void wheelEvent(QWheelEvent *event);

    public:
        DrawWidget(QWidget *parent = 0);
};

#endif // DRAWWIDGET_H
