#ifndef MAP_H
#define MAP_H

#include <scene.h>

struct Pixel
{
   enum Type {
      BEDROCK, GRASS, TREE, BERRIES, ROCK, IRON_ORE, // nature
      FOOD, WOOD, STONE, IRON, SWORD, // resources
      DUDE, DEAD_DUDE, // humans
      SPAWN, WALL, ROAD, MARK, LIBRARY // buildings
   };
   
   union PixelData {
      int nbRes;
      void* knowledge;
   };
   
   int type;
   PixelData data;
};

class Map : public BasicScene
{
    MapData map;
    int m_width;
    int m_height;

public:
    Map(int width, int height = 0);

    int getWidth() { return m_width; }
    int getHeight() { return m_height; }
};

#endif // MAP_H
